#!/bin/bash
# SierraAMD Post install script
# Shaneee - http://amd-osx.com
#

# Ask the user what drive Sierra is installed on
while [ ! -d /Volumes/$VOLUME/System ]; do
    printf "\nPlease enter the name of the disk Sierra is installed on (Leave blank to exit):\n"
    read VOLUME
    if [ -z $VOLUME ]; then #if no value was entered
        exit 1
    fi
    if [ -d /Volumes/$VOLUME/System ]; then
        break
    else
        printf "\nNot a valid install!\n"
    fi
done

# Copy Kernel
printf "\nInstalling AMD Kernel\n"
CPU=$(sysctl -n machdep.cpu.brand_string | grep -i Ryzen)
if [ ! -z "$CPU" ]; then
    cp /Volumes/SierraAMD/PostInstall/kernel-ryzen /Volumes/$VOLUME/System/Library/Kernels/kernel
else
    cp /Volumes/SierraAMD/PostInstall/kernel-fx /Volumes/$VOLUME/System/Library/Kernels/kernel
fi

# Copy Kexts
printf "\nCopying the Kexts\n"
cp -rf /Volumes/SierraAMD/PostInstall/Kexts/*.kext /Volumes/$VOLUME/System/Library/Extensions/

# Copy Extra Folder
printf "\nCopying the Extra folder\n"
cp -rf /Volumes/SierraAMD/PostInstall/Extra /Volumes/$VOLUME/

# Remove Problem Kexts
printf "\nRemoving Problem Kexts\n"
rm -rf /Volumes/$VOLUME/System/Library/Extensions/AppleIntelCPUPowerManagement.kext
rm -rf /Volumes/$VOLUME/System/Library/Extensions/pmtelemetry.kext
rm -rf /Volumes/$VOLUME/System/Library/Extensions/AppleTyMCEDriver.kext

# Remove old PrelinkedKernel and rebuild.
printf "\nRemoving the old PrelinkedKernel and rebuilding for AMD\n"
rm -rf /Volumes/$VOLUME/System/Library/PrelinkedKernels/prelinkedkernel
kextcache -u /Volumes/$VOLUME/

# Ask to remove the unneeded Recovery Partition
printf "\nWould you like to remove the Recovery Partition? (This is unusable by your AMD Mac)\n(y/n):\n"
read INPUT
if [ $INPUT == "y" ]; then
    RECOVERY=$(awk '{print substr($0, length($0)-7)}' <<< $(diskutil list | grep "Recovery HD"))
    MAINDISK=$(awk '{print substr($0, length($0)-7)}' <<< $(diskutil list | grep "$VOLUME"))
    # There must be a result and it must be on the same disk
    if [ -z $RECOVERY ] || [ $(awk '{print substr($0, length($0)-7,6)}' <<< "$RECOVERY") != $(awk '{print substr($0, length($0)-7,6)}' <<< "$MAINDISK") ]; then
        printf "\nNo Recovery Drive found!\n"   
    else
        printf "\nRemoving Recovery Partition"
        diskutil eraseVolume HFS+ Blank $RECOVERY
        printf "\nMerging Partitions with Main Partition"
        diskutil mergePartitions HFS+ $VOLUME $MAINDISK $RECOVERY
        printf "\nDone!\n"
    fi
fi

printf "\nYour System should now be able to boot.\n\nNote: you will need to use the USB to boot for the first time.\nFor post install support visit http://amd-osx.com/\nDonations are gratefully accepted.\n\nEnjoy your System\n-Shaneee\n\n\nThe System will reboot in one minute or you can do it manually.\n"
shutdown -r +1
exit 0
